"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Button = void 0;
const react_1 = __importStar(require("react"));
const css_1 = require("@emotion/css");
const ThemeProvider_1 = require("../../theme/ThemeProvider");
const Icon_1 = require("../Icon/Icon");
function ButtonIcon({ loading, icon, classNames }) {
    if (loading) {
        return (react_1.default.createElement("span", { className: (0, css_1.cx)('ref-button-icon', classNames === null || classNames === void 0 ? void 0 : classNames.icon) },
            react_1.default.createElement(Icon_1.LoaderIcon, null)));
    }
    if (icon) {
        return react_1.default.createElement("span", { className: (0, css_1.cx)('ref-button-icon', classNames === null || classNames === void 0 ? void 0 : classNames.icon) }, icon);
    }
    return null;
}
function Button({ icon, className, children, onClick, classNames, disabled, loading }) {
    const { theme, css } = (0, react_1.useContext)(ThemeProvider_1.ThemeContext);
    const internalClassName = css `
    background: ${disabled ? theme.colors.secondary.main : theme.colors.primary.main};
    border: 0;
    border-radius: ${theme.shape.borderRadius};
    color: ${theme.colors.primary.text};
    cursor: ${disabled ? 'not-allowed' : 'pointer'};
    padding: ${theme.spacing[4]};
    position: relative;

    &:hover,
    &:focus {
      background: ${disabled ? theme.colors.secondary.main : theme.colors.primary.dark};
    }

    &:active {
      top: 1px;
    }
  `;
    return (react_1.default.createElement("button", { disabled: disabled, className: (0, css_1.cx)('ref-button', loading && 'ref-button-loading', internalClassName, className), type: "button", onClick: onClick },
        react_1.default.createElement(ButtonIcon, { loading: loading, icon: icon, classNames: classNames }),
        react_1.default.createElement("span", { className: (0, css_1.cx)('ref-button-text', classNames === null || classNames === void 0 ? void 0 : classNames.text) }, children)));
}
exports.Button = Button;
