"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
const react_1 = require("@testing-library/react");
const user_event_1 = __importDefault(require("@testing-library/user-event"));
const Button_1 = require("./Button");
describe('Button', () => {
    it('should show basic button with text', () => {
        (0, react_1.render)(React.createElement(Button_1.Button, { onClick: () => null }, "Example"));
        expect(react_1.screen.getByText(/Example/)).toBeInTheDocument();
    });
    it('should show basic button with text and icon', () => {
        (0, react_1.render)(React.createElement(Button_1.Button, { icon: React.createElement(React.Fragment, null, "Icon"), onClick: () => null }, "Example"));
        expect(react_1.screen.getByText(/Icon/)).toBeInTheDocument();
    });
    it('should add css classes', () => {
        var _a, _b;
        const { container } = (0, react_1.render)(React.createElement(Button_1.Button, { classNames: { icon: 'iconclass', text: 'textclass' }, onClick: () => null, icon: React.createElement(React.Fragment, null, "Icon") }, "Example"));
        expect((_a = container.firstChild) === null || _a === void 0 ? void 0 : _a.childNodes[0]).toHaveClass('iconclass');
        expect((_b = container.firstChild) === null || _b === void 0 ? void 0 : _b.childNodes[1]).toHaveClass('textclass');
    });
    it('should respond to onClick action', () => __awaiter(void 0, void 0, void 0, function* () {
        const onClick = jest.fn();
        (0, react_1.render)(React.createElement(Button_1.Button, { onClick: onClick }, "Example"));
        yield user_event_1.default.click(react_1.screen.getByRole('button'));
        expect(onClick).toBeCalled();
    }));
    it('should show loading state', () => __awaiter(void 0, void 0, void 0, function* () {
        (0, react_1.render)(React.createElement(Button_1.Button, { onClick: () => null, loading: true }, "Example"));
        expect(react_1.screen.getByText(/Loading.../)).toBeInTheDocument();
    }));
    it('should show loading state with icon', () => __awaiter(void 0, void 0, void 0, function* () {
        const { rerender } = (0, react_1.render)(React.createElement(Button_1.Button, { onClick: () => null, icon: React.createElement(React.Fragment, null, "Icon"), loading: true, classNames: { icon: 'iconclass' } }, "Example"));
        expect(react_1.screen.queryByText(/Icon/)).not.toBeInTheDocument();
        expect(react_1.screen.getByText(/Loading.../)).toBeInTheDocument();
        rerender(React.createElement(Button_1.Button, { onClick: () => null, icon: React.createElement(React.Fragment, null, "Icon"), loading: false }, "Example"));
        expect(react_1.screen.queryByText(/Icon/)).toBeInTheDocument();
        expect(react_1.screen.queryByText(/Loading.../)).not.toBeInTheDocument();
    }));
});
