"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Flex = exports.FlexItem = void 0;
const react_1 = __importDefault(require("react"));
const css_1 = require("@emotion/css");
const width_map_1 = __importDefault(require("../../utils/width-map"));
function FlexItem({ children, sm }) {
    const className = (0, css_1.css) `
    width: ${sm ? width_map_1.default[sm] : '100%'};
  `;
    return react_1.default.createElement("div", { className: className }, children);
}
exports.FlexItem = FlexItem;
function Flex({ children, className, justify, align }) {
    const internalClassName = (0, css_1.css) `
    display: flex;
    justify-content: ${justify};
    align-items: ${align};
  `;
    return react_1.default.createElement("div", { className: (0, css_1.cx)(className, internalClassName) }, children);
}
exports.Flex = Flex;
Flex.Item = FlexItem;
