"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tabs = void 0;
const react_1 = __importStar(require("react"));
const css_1 = require("@emotion/css");
const ThemeProvider_1 = require("../../theme/ThemeProvider");
function TabPane({ children }) {
    return react_1.default.createElement("div", null, children);
}
function Tabs({ className, children, classNames, activeTab }) {
    const { theme, css } = (0, react_1.useContext)(ThemeProvider_1.ThemeContext);
    const arrayChildren = react_1.Children.toArray(children);
    const [active, setActive] = (0, react_1.useState)(arrayChildren.find((tab) => tab.props.id === activeTab) || arrayChildren[0]);
    const internalStyles = {
        container: css ``,
        tabs: css `
      display: flex;
    `,
        tab: css `
      border: 0;
      cursor: pointer;
      padding: ${theme.spacing[2]};
    `,
        tabActive: css `
      border: 0;
      cursor: pointer;
      background: ${theme.colors.primary.main};
      padding: ${theme.spacing[2]};
    `,
        content: css `
      padding: ${theme.spacing[2]};
    `
    };
    const onTabSelect = (id) => {
        const tab = arrayChildren.find((child) => child.props.id === id);
        if (tab) {
            setActive(tab);
        }
    };
    return (react_1.default.createElement("div", { className: (0, css_1.cx)('ref-tabs', internalStyles.container, className) },
        react_1.default.createElement("div", { className: (0, css_1.cx)('ref-tabs-tabs', internalStyles.tabs, classNames === null || classNames === void 0 ? void 0 : classNames.tabs) }, react_1.Children.map(arrayChildren, (child) => {
            return (react_1.default.createElement("button", { type: "button", className: (0, css_1.cx)(child.props.id === active.props.id
                    ? 'ref-tabs-tab ref-tabs-tab--active'
                    : 'ref-tabs-tab', child.props.id === active.props.id
                    ? internalStyles.tabActive
                    : internalStyles.tab, classNames === null || classNames === void 0 ? void 0 : classNames.tab), key: child.props.id, onClick: () => onTabSelect(child.props.id) }, child.props.title));
        })),
        react_1.default.createElement("div", { className: (0, css_1.cx)('ref-tabs-content', internalStyles.content, classNames === null || classNames === void 0 ? void 0 : classNames.content) }, active)));
}
exports.Tabs = Tabs;
Tabs.TabPane = TabPane;
