"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
const react_1 = require("@testing-library/react");
const user_event_1 = __importDefault(require("@testing-library/user-event"));
const index_1 = require("../../index");
describe('Tabs', () => {
    it('should show basic tabs', () => {
        (0, react_1.render)(React.createElement(index_1.Tabs, null,
            React.createElement(index_1.Tabs.TabPane, { title: "Tab 1", id: "tab1" }, "Test 1"),
            React.createElement(index_1.Tabs.TabPane, { title: "Tab 2", id: "tab2" }, "Test 2")));
        expect(react_1.screen.getByText(/Tab 1/)).toBeInTheDocument();
        expect(react_1.screen.getByText(/Tab 2/)).toBeInTheDocument();
        expect(react_1.screen.queryByText(/Test 1/)).toBeInTheDocument();
        expect(react_1.screen.queryByText(/Test 2/)).not.toBeInTheDocument();
    });
    it('should switch tab content', () => __awaiter(void 0, void 0, void 0, function* () {
        (0, react_1.render)(React.createElement(index_1.Tabs, null,
            React.createElement(index_1.Tabs.TabPane, { title: "Tab 1", id: "tab1" }, "Test 1"),
            React.createElement(index_1.Tabs.TabPane, { title: "Tab 2", id: "tab2" }, "Test 2")));
        yield user_event_1.default.click(react_1.screen.getByText(/Tab 2/));
        expect(react_1.screen.queryByText(/Test 1/)).not.toBeInTheDocument();
        expect(react_1.screen.queryByText(/Test 2/)).toBeInTheDocument();
    }));
});
